Codeforces Round #290 (Div. 1) B. Fox And Jumping

来源:互联网 发布:沉迷于网络的危害 编辑:程序博客网 时间:2024/05/18 02:43

题意:给出300个数,每个数有权值,求从中挑出k个数使得它们的gcd为1的最小代价。。。。

解法:因为每个数对应的素数并不是很多,因此dp的状态并不是很多。。。

#include <iostream>#include <queue>#include <stack>#include <map>#include <set>#include <bitset>#include <cstdio>#include <algorithm>#include <cstring>#include <climits>#include <cstdlib>#include <cmath>#include <time.h>#define maxn 305#define maxm 200005#define eps 1e-7#define mod 1000000007#define INF 0x3f3f3f3f#define PI (acos(-1.0))#define lowbit(x) (x&(-x))#define mp make_pair#define ls o<<1#define rs o<<1 | 1#define lson o<<1, L, mid #define rson o<<1 | 1, mid+1, R#define pii pair<int, int>#pragma comment(linker, "/STACK:16777216")typedef long long LL;typedef unsigned long long ULL;using namespace std;LL qpow(LL a, LL b){LL res=1,base=a;while(b){if(b%2)res=res*base;base=base*base;b/=2;}return res;}LL powmod(LL a, LL b){LL res=1,base=a;while(b){if(b%2)res=res*base%mod;base=base*base%mod;b/=2;}return res;}//headmap<pair<int, int>, int> dp;int a[maxn];int b[maxn];int n;void read(){scanf("%d", &n);for(int i = 0; i < n; i++) scanf("%d", &a[i]);for(int i = 0; i < n; i++) scanf("%d", &b[i]);}int dfs(int g, int now){if(dp.count(mp(g, now))) return dp[mp(g, now)];if(g == 1) return 0;if(now == n) return INF;int res = min(dfs(g, now + 1), dfs(__gcd(g, a[now]), now + 1) + b[now]);return dp[mp(g, now)] = res;}void work(){int ans = 0;for(int i = 0; i < n; i++) ans = __gcd(ans, a[i]);if(ans != 1) printf("-1\n");else printf("%d\n", dfs(0, 0));}int main(){read();work();return 0;}


0 0
原创粉丝点击